;RNG DLL Template for use with RNGtests.exe.
;The functions RandomIntArray and InitRand32 must be exported, so edit the DEF 
;file accordingly.  The three procedures may be modified as you will, bearing in 
;mind that their I/O must match requirements of RNGtests.exe.

.NOLIST
.586
.model flat,stdcall
option casemap:none
include	\masm32\include\windows.inc

Rand32		proto	:DWORD
InitRand32	proto   :DWORD

.data?
seed	dd	?

.code
DllEntry	proc	hinstance:HINSTANCE, reason:DWORD, reserved1:DWORD
		invoke  InitRand32,0
		mov	eax,TRUE
		ret
DllEntry	endp

;Usage: RandomIntArray(Data:pointer,count:int,base:int,seed:int),int
;Returns a series of random integers, base>n>=0, to a dword array.  seed is not
;used with RNGtests.exe, and is always -1.
RandomIntArray	proc uses esi pData:PTR DWORD, count:DWORD, base:DWORD, sede:dword
;	invoke  InitRand32,sede
	mov     esi,pData
	mov     ecx,count
	mov     edx,base
@@:	or      ecx,ecx
	jz      @F
	push    ecx
	push    edx
	invoke  Rand32,edx
	pop     edx
	pop     ecx
	mov     [esi],eax
	add     esi,4
	dec     ecx
	jmp     @B
@@:	ret
RandomIntArray  endp

;Usage: InitRand32(seed:int)
;Sets a starting seed for random number generation.  An input value of zero 
;uses the cpu time-stamp clock ;as a 'randomize' option.  A negative seed 
;avoids reseeding, allowing queries without changes.  The function returns 
;the current seed.  RNGtests.exe calls this function to set the initial seed 
;for a run and queries this function (seed=-1) to find the seed at the start 
;of each loop for display only.
;
InitRand32	proc	new_seed:DWORD
	mov	eax,new_seed	;valid seeds range 1 thru 7ffffffeh
	test	eax,eax
	jnz	ir01		;If non-zero seed specified
@@:	rdtsc			; else get value from CPU clock
	and	eax,7fffffffh	; and clear msbit for a valid seed
	jz	@B		;IF TSC seed just happens to be 0 then retry

ir01:	cmp	eax,7fffffffh	;If seed > 7ffffffe, no changes
	jb	@F
	mov	eax,seed
@@:	mov	seed,eax
	cmp	eax,new_seed	;set flags returned for possible testing
	ret			;return seed value
InitRand32	endp

;Usage: Rand32(base:int)
;Return a number ranging from 0 to base-1 in eax.
;
Rand32	proc	base:DWORD
;*******************************************************************
;Insert RNG code here to read the current seed, modify it according to 
;your algorithm and return a new number mod base in eax.
;*******************************************************************
Rand32	endp

End DllEntry
